=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2012-02-23 23:41:51 +0000
+++ bzrlib/branch.py	2012-03-14 11:49:29 +0000
@@ -766,11 +766,6 @@
         """Print `file` to stdout."""
         raise NotImplementedError(self.print_file)
 
-    @deprecated_method(deprecated_in((2, 4, 0)))
-    def set_revision_history(self, rev_history):
-        """See Branch.set_revision_history."""
-        self._set_revision_history(rev_history)
-
     @needs_write_lock
     def _set_revision_history(self, rev_history):
         if len(rev_history) == 0:
@@ -1013,16 +1008,6 @@
         """
         raise NotImplementedError(self._gen_revision_history)
 
-    @deprecated_method(deprecated_in((2, 5, 0)))
-    @needs_read_lock
-    def revision_history(self):
-        """Return sequence of revision ids on this branch.
-
-        This method will cache the revision history for as long as it is safe to
-        do so.
-        """
-        return self._revision_history()
-
     def _revision_history(self):
         if 'evil' in debug.debug_flags:
             mutter_callsite(3, "revision_history scales with history.")
@@ -2778,12 +2763,6 @@
         else:
             return (0, _mod_revision.NULL_REVISION)
 
-    @deprecated_method(deprecated_in((2, 4, 0)))
-    @needs_write_lock
-    def set_revision_history(self, rev_history):
-        """See Branch.set_revision_history."""
-        self._set_revision_history(rev_history)
-
     def _set_revision_history(self, rev_history):
         if 'evil' in debug.debug_flags:
             mutter_callsite(3, "set_revision_history scales with history.")

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2012-02-23 19:45:15 +0000
+++ bzrlib/remote.py	2012-03-14 11:49:29 +0000
@@ -3792,12 +3792,6 @@
             raise errors.UnexpectedSmartServerResponse(response)
         self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    @needs_write_lock
-    def set_revision_history(self, rev_history):
-        """See Branch.set_revision_history."""
-        self._set_revision_history(rev_history)
-
     @needs_write_lock
     def _set_revision_history(self, rev_history):
         # Send just the tip revision of the history; the server will generate

=== modified file 'bzrlib/tests/per_branch/__init__.py'
--- bzrlib/tests/per_branch/__init__.py	2011-10-05 12:51:41 +0000
+++ bzrlib/tests/per_branch/__init__.py	2012-03-14 11:49:29 +0000
@@ -169,7 +169,6 @@
         'pull',
         'push',
         'reconcile',
-        'revision_history',
         'revision_id_to_dotted_revno',
         'revision_id_to_revno',
         'sprout',

=== modified file 'bzrlib/tests/per_branch/test_branch.py'
--- bzrlib/tests/per_branch/test_branch.py	2012-02-23 23:26:35 +0000
+++ bzrlib/tests/per_branch/test_branch.py	2012-03-14 11:49:29 +0000
@@ -475,17 +475,6 @@
         checkout = source_branch.create_checkout('c')
         self.assertEqual(rev_id, checkout.last_revision())
 
-    def test_set_revision_history(self):
-        tree = self.make_branch_and_tree('a')
-        tree.commit('a commit', rev_id='rev1')
-        br = tree.branch
-        self.applyDeprecated(symbol_versioning.deprecated_in((2, 4, 0)),
-            br.set_revision_history, ["rev1"])
-        self.assertEquals(br.last_revision(), "rev1")
-        self.applyDeprecated(symbol_versioning.deprecated_in((2, 4, 0)),
-            br.set_revision_history, [])
-        self.assertEquals(br.last_revision(), 'null:')
-
     def test_heads_to_fetch(self):
         # heads_to_fetch is a method that returns a collection of revids that
         # need to be fetched to copy this branch into another repo.  At a

=== modified file 'bzrlib/tests/per_branch/test_get_revision_id_to_revno_map.py'
--- bzrlib/tests/per_branch/test_get_revision_id_to_revno_map.py	2011-04-19 14:17:24 +0000
+++ bzrlib/tests/per_branch/test_get_revision_id_to_revno_map.py	2012-03-14 11:49:29 +0000
@@ -81,24 +81,6 @@
         finally:
             branch.unlock()
 
-    def test_set_revision_history_when_locked(self):
-        """Calling set_revision_history should reset the cache."""
-        branch, calls = self.get_instrumented_branch()
-        branch.lock_write()
-        try:
-            self.assertEqual({'rev-1':(1,), 'rev-2':(2,), 'rev-3':(3,),
-                              'rev-1.1.1':(1,1,1)
-                             }, branch.get_revision_id_to_revno_map())
-            self.applyDeprecated(deprecated_in((2, 4, 0)),
-                branch.set_revision_history, ['rev-1', 'rev-2'])
-            self.assertEqual({'rev-1':(1,), 'rev-2':(2,)},
-                             branch.get_revision_id_to_revno_map())
-            self.assertEqual({'rev-1':(1,), 'rev-2':(2,)},
-                             branch.get_revision_id_to_revno_map())
-            self.assertEqual(['_gen_revno_map']*2, calls)
-        finally:
-            branch.unlock()
-
     def test_set_last_revision_info_when_locked(self):
         """Calling set_last_revision_info should reset the cache."""
         branch, calls = self.get_instrumented_branch()

=== removed file 'bzrlib/tests/per_branch/test_revision_history.py'
--- bzrlib/tests/per_branch/test_revision_history.py	2011-10-05 12:45:41 +0000
+++ bzrlib/tests/per_branch/test_revision_history.py	1970-01-01 00:00:00 +0000
@@ -1,231 +0,0 @@
-# Copyright (C) 2007-2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for Branch.revision_history and last_revision."""
-
-from bzrlib import (
-    branch,
-    errors,
-    revision as _mod_revision,
-    )
-from bzrlib.symbol_versioning import deprecated_in
-from bzrlib.tests import (
-    per_branch,
-    TestNotApplicable,
-    )
-
-
-class TestLastRevision(per_branch.TestCaseWithBranch):
-    """Tests for the last_revision property of the branch.
-    """
-
-    def test_set_last_revision_info(self):
-        # based on TestBranch.test_append_revisions, which uses the old
-        # append_revision api
-        wt = self.make_branch_and_tree('tree')
-        wt.commit('f', rev_id='rev1')
-        wt.commit('f', rev_id='rev2')
-        wt.commit('f', rev_id='rev3')
-        br = self.get_branch()
-        br.fetch(wt.branch)
-        br.set_last_revision_info(1, 'rev1')
-        self.assertEquals(
-            self.applyDeprecated(deprecated_in((2, 5, 0)), br.revision_history),
-            ["rev1",])
-        br.set_last_revision_info(3, 'rev3')
-        self.assertEquals(
-            self.applyDeprecated(deprecated_in((2, 5, 0)), br.revision_history),
-            ["rev1", "rev2", "rev3"])
-        # append_revision specifically prohibits some ids;
-        # set_last_revision_info currently does not
-        ## self.assertRaises(errors.ReservedId,
-        ##         br.set_last_revision_info, 4, 'current:')
-
-
-class TestRevisionHistoryCaching(per_branch.TestCaseWithBranch):
-    """Tests for the caching of branches' revision_history.
-
-    When locked, branches should avoid regenerating or rereading
-    revision_history by caching the last value of it.  This is safe because
-    the branch is locked, so nothing can change the revision_history
-    unexpectedly.
-
-    When not locked, obviously the revision_history will need to be regenerated
-    or reread each time.
-
-    We test if revision_history is using the cache by instrumenting the branch's
-    _gen_revision_history method, which is called by Branch.revision_history if
-    the branch does not have a cache of the revision history.
-    """
-
-    def get_instrumented_branch(self):
-        """Get a branch and monkey patch it to log calls to
-        _gen_revision_history.
-
-        :returns: a tuple of (the branch, list that calls will be logged to)
-        """
-        branch = self.get_branch()
-        calls = []
-        real_gen_revision_history = branch._gen_revision_history
-        def fake_gen_revision_history():
-            calls.append('_gen_revision_history')
-            return real_gen_revision_history()
-        branch._gen_revision_history = fake_gen_revision_history
-        return branch, calls
-
-    def test_revision_history_when_unlocked(self):
-        """Repeated calls to revision history will call _gen_revision_history
-        each time when the branch is not locked.
-        """
-        branch, calls = self.get_instrumented_branch()
-        # Repeatedly call revision_history.
-        self.applyDeprecated(deprecated_in((2, 5, 0)), branch.revision_history)
-        self.applyDeprecated(deprecated_in((2, 5, 0)), branch.revision_history)
-        self.assertEqual(
-            ['_gen_revision_history', '_gen_revision_history'], calls)
-
-    def test_revision_history_when_locked(self):
-        """Repeated calls to revision history will only call
-        _gen_revision_history once while the branch is locked.
-        """
-        branch, calls = self.get_instrumented_branch()
-        # Lock the branch, then repeatedly call revision_history.
-        branch.lock_read()
-        try:
-            self.applyDeprecated(deprecated_in((2, 5, 0)),
-                branch.revision_history)
-            self.applyDeprecated(deprecated_in((2, 5, 0)),
-                branch.revision_history)
-            self.assertEqual(['_gen_revision_history'], calls)
-        finally:
-            branch.unlock()
-
-    def test_set_revision_history_when_locked(self):
-        """When the branch is locked, calling set_revision_history should cache
-        the revision history so that a later call to revision_history will not
-        need to call _gen_revision_history.
-        """
-        branch, calls = self.get_instrumented_branch()
-        # Lock the branch, set the revision history, then repeatedly call
-        # revision_history.
-        branch.lock_write()
-        self.applyDeprecated(deprecated_in((2, 4, 0)),
-            branch.set_revision_history, [])
-        try:
-            self.applyDeprecated(deprecated_in((2, 5, 0)),
-                branch.revision_history)
-            self.assertEqual([], calls)
-        finally:
-            branch.unlock()
-
-    def test_set_revision_history_when_unlocked(self):
-        """When the branch is not locked, calling set_revision_history will not
-        cause the revision history to be cached.
-        """
-        branch, calls = self.get_instrumented_branch()
-        self.applyDeprecated(deprecated_in((2, 4, 0)),
-            branch.set_revision_history, [])
-        self.applyDeprecated(deprecated_in((2, 5, 0)),
-            branch.revision_history)
-        self.assertEqual(['_gen_revision_history'], calls)
-
-    def test_set_last_revision_info_when_locked(self):
-        """When the branch is locked, calling set_last_revision_info should
-        cache the last revision info so that a later call to last_revision_info
-        will not need the revision_history.  Thus the branch will not to call
-        _gen_revision_history in this situation.
-        """
-        a_branch, calls = self.get_instrumented_branch()
-        # Lock the branch, set the last revision info, then call
-        # last_revision_info.
-        a_branch.lock_write()
-        a_branch.set_last_revision_info(0, _mod_revision.NULL_REVISION)
-        del calls[:]
-        try:
-            a_branch.last_revision_info()
-            self.assertEqual([], calls)
-        finally:
-            a_branch.unlock()
-
-    def test_set_last_revision_info_none(self):
-        """Passing None to set_last_revision_info raises an exception."""
-        a_branch = self.get_branch()
-        # Lock the branch, set the last revision info, then call
-        # last_revision_info.
-        a_branch.lock_write()
-        self.addCleanup(a_branch.unlock)
-        self.assertRaises(errors.InvalidRevisionId,
-            a_branch.set_last_revision_info, 0, None)
-
-    def test_set_last_revision_info_uncaches_revision_history_for_format6(self):
-        """On format 6 branches, set_last_revision_info invalidates the revision
-        history cache.
-        """
-        if not isinstance(self.branch_format, branch.BzrBranchFormat6):
-            return
-        a_branch, calls = self.get_instrumented_branch()
-        # Lock the branch, cache the revision history.
-        a_branch.lock_write()
-        self.applyDeprecated(deprecated_in((2, 5, 0)),
-            a_branch.revision_history)
-        # Set the last revision info, clearing the cache.
-        a_branch.set_last_revision_info(0, _mod_revision.NULL_REVISION)
-        del calls[:]
-        try:
-            self.applyDeprecated(deprecated_in((2, 5, 0)),
-                a_branch.revision_history)
-            self.assertEqual(['_gen_revision_history'], calls)
-        finally:
-            a_branch.unlock()
-
-    def test_cached_revision_history_not_accidentally_mutable(self):
-        """When there's a cached version of the history, revision_history
-        returns a copy of the cached data so that callers cannot accidentally
-        corrupt the cache.
-        """
-        branch = self.get_branch()
-        # Lock the branch, then repeatedly call revision_history, mutating the
-        # results.
-        branch.lock_read()
-        try:
-            # The first time the data returned will not be in the cache.
-            history = self.applyDeprecated(deprecated_in((2, 5, 0)),
-                branch.revision_history)
-            history.append('one')
-            # The second time the data comes from the cache.
-            history = self.applyDeprecated(deprecated_in((2, 5, 0)),
-                branch.revision_history)
-            history.append('two')
-            # The revision_history() should still be unchanged, even though
-            # we've mutated the return values from earlier calls.
-            self.assertEqual([], self.applyDeprecated(
-                deprecated_in((2, 5, 0)), branch.revision_history))
-        finally:
-            branch.unlock()
-
-
-class TestRevisionHistory(per_branch.TestCaseWithBranch):
-
-    def test_parent_ghost(self):
-        tree = self.make_branch_and_tree('tree')
-        if not tree.branch.repository._format.supports_ghosts:
-            raise TestNotApplicable("repository format does not support ghosts")
-        tree.add_parent_tree_id('ghost-revision',
-                                allow_leftmost_as_ghost=True)
-        tree.commit('first non-ghost commit', rev_id='non-ghost-revision')
-        self.assertEqual(['non-ghost-revision'],
-                         self.applyDeprecated(deprecated_in((2, 5, 0)),
-                            tree.branch.revision_history))

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2012-02-23 19:45:15 +0000
+++ bzrlib/tests/test_remote.py	2012-03-14 11:49:29 +0000
@@ -121,15 +121,6 @@
         self.local_wt.commit(message='test commit', rev_id=revid)
         self.assertTrue(repo.has_revision(revid))
 
-    def test_remote_branch_revision_history(self):
-        b = BzrDir.open_from_transport(self.transport).open_branch()
-        self.assertEqual([],
-            self.applyDeprecated(deprecated_in((2, 5, 0)), b.revision_history))
-        r1 = self.local_wt.commit('1st commit')
-        r2 = self.local_wt.commit('1st commit', rev_id=u'\xc8'.encode('utf8'))
-        self.assertEqual([r1, r2],
-            self.applyDeprecated(deprecated_in((2, 5, 0)), b.revision_history))
-
     def test_find_correct_format(self):
         """Should open a RemoteBzrDir over a RemoteTransport"""
         fmt = BzrDirFormat.find_format(self.transport)

